function Pin(name, gps, textureFile) {
   this.name = name;
   this.gps = gps;
   this.textureFile = textureFile;
   this.buffers = this.InitBuffers();
   this.texture = this.InitTexture();
}

Pin.prototype.InitTexture = function() {
   var texture = gl.createTexture();
   texture.image = new Image();
   texture.image.onload = function () {
      HandleLoadedTexture(texture);
   }
   texture.image.src = this.textureFile;

   return texture;
}

Pin.prototype.InitBuffers = function() {
   this.vertexCount = 36;
   /*var indices = [
      0, 1, 2,      0, 2, 3,    // Front face
      4, 5, 6,      4, 6, 7,    // Back face
      8, 9, 10,     8, 10, 11,  // Top face
      12, 13, 14,   12, 14, 15, // Bottom face
      16, 17, 18,   16, 18, 19, // Right face
      20, 21, 22,   20, 22, 23  // Left face
   ];*/

   positions = [
      // Front face
      -1.0, -1.0,  1.0,
       1.0,  1.0,  1.0,
       1.0, -1.0,  1.0,

      -1.0, -1.0,  1.0,
      -1.0,  1.0,  1.0,
       1.0,  1.0,  1.0,

      // Back face
      -1.0, -1.0, -1.0,
       1.0,  1.0, -1.0,
       1.0, -1.0, -1.0,

      -1.0, -1.0, -1.0,
      -1.0,  1.0, -1.0,
       1.0,  1.0, -1.0,

      // Top face
      -1.0,  1.0,  1.0,
       1.0,  1.0, -1.0,
       1.0,  1.0,  1.0,

      -1.0,  1.0,  1.0,
      -1.0,  1.0, -1.0,
       1.0,  1.0, -1.0,

      // Bottom face
      -1.0, -1.0, -1.0,
       1.0, -1.0,  1.0,
       1.0, -1.0, -1.0,

      -1.0, -1.0, -1.0,
      -1.0, -1.0,  1.0,
       1.0, -1.0,  1.0,

      // Right face
       1.0, -1.0,  1.0,
       1.0,  1.0, -1.0,
       1.0, -1.0, -1.0,

       1.0, -1.0,  1.0,
       1.0,  1.0,  1.0,
       1.0,  1.0, -1.0,

      // Left face
      -1.0, -1.0, -1.0,
      -1.0,  1.0,  1.0,
      -1.0, -1.0,  1.0,

      -1.0, -1.0, -1.0,
      -1.0,  1.0, -1.0,
      -1.0,  1.0,  1.0
   ];

   var textures = [
      // Front face
      0.0, 0.0,
      1.0, 1.0,
      1.0, 0.0,

      0.0, 0.0,
      0.0, 1.0,
      1.0, 1.0,

      // Back face
      0.0, 0.0,
      1.0, 1.0,
      1.0, 0.0,

      0.0, 0.0,
      0.0, 1.0,
      1.0, 1.0,

      // Top face
      0.0, 0.0,
      1.0, 1.0,
      1.0, 0.0,

      0.0, 0.0,
      0.0, 1.0,
      1.0, 1.0,

      // Bottom face
      0.0, 0.0,
      1.0, 1.0,
      1.0, 0.0,

      0.0, 0.0,
      0.0, 1.0,
      1.0, 1.0,

      // Right face
      0.0, 0.0,
      1.0, 1.0,
      1.0, 0.0,

      0.0, 0.0,
      0.0, 1.0,
      1.0, 1.0,

      // Left face
      0.0, 0.0,
      1.0, 1.0,
      1.0, 0.0,

      0.0, 0.0,
      0.0, 1.0,
      1.0, 1.0
   ];

 /*  var normalData = [
       new Vertex(0.0,  0.0,  1.0),
       new Vertex(0.0,  0.0, -1.0),
       new Vertex(0.0,  1.0,  0.0),
       new Vertex(0.0, -1.0,  0.0),
       new Vertex(1.0,  0.0,  0.0),
       new Vertex(-1.0, 0.0,  0.0)
   ];

   var normals = new Array();
   var count= 0;
   for (var i = 0; i < 6; i++) {
      for (var j = 0; j < 4; j++) {
         normals[count++] = normalData[i].x;
         normals[count++] = normalData[i].y;
         normals[count++] = normalData[i].z;
      }
   }*/

   var normals = [
      // Front face
       0.0,  0.0,  1.0,
       0.0,  0.0,  1.0,
       0.0,  0.0,  1.0,

       0.0,  0.0,  1.0,
       0.0,  0.0,  1.0,
       0.0,  0.0,  1.0,

      // Back face
       0.0,  0.0, -1.0,
       0.0,  0.0, -1.0,
       0.0,  0.0, -1.0,

       0.0,  0.0, -1.0,
       0.0,  0.0, -1.0,
       0.0,  0.0, -1.0,

      // Top face
       0.0,  1.0,  0.0,
       0.0,  1.0,  0.0,
       0.0,  1.0,  0.0,

       0.0,  1.0,  0.0,
       0.0,  1.0,  0.0,
       0.0,  1.0,  0.0,

      // Bottom face
       0.0, -1.0,  0.0,
       0.0, -1.0,  0.0,
       0.0, -1.0,  0.0,

       0.0, -1.0,  0.0,
       0.0, -1.0,  0.0,
       0.0, -1.0,  0.0,

      // Right face
       1.0,  0.0,  0.0,
       1.0,  0.0,  0.0,
       1.0,  0.0,  0.0,

       1.0,  0.0,  0.0,
       1.0,  0.0,  0.0,
       1.0,  0.0,  0.0,

      // Left face
      -1.0,  0.0,  0.0,
      -1.0,  0.0,  0.0,
      -1.0,  0.0,  0.0,

      -1.0,  0.0,  0.0,
      -1.0,  0.0,  0.0,
      -1.0,  0.0,  0.0
   ];

  /* var indices = [
      0, 1, 2,      0, 2, 3,    // Front face
      4, 5, 6,      4, 6, 7,    // Back face
      8, 9, 10,     8, 10, 11,  // Top face
      12, 13, 14,   12, 14, 15, // Bottom face
      16, 17, 18,   16, 18, 19, // Right face
      20, 21, 22,   20, 22, 23  // Left face
   ];*/

   return this.BindGLBuffers(this.vertexCount, positions, textures, normals);
}

Pin.prototype.BindGLBuffers = function(count, vertexPositions, vertexTextureCoords, vertexNormals) {
   var vertexPositionBuffer, vertexTextureCoordBuffer, vertexNormalBuffer;

   vertexPositionBuffer = gl.createBuffer();
   gl.bindBuffer(gl.ARRAY_BUFFER, vertexPositionBuffer);
   gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertexPositions), gl.STATIC_DRAW);
   vertexPositionBuffer.itemSize = 3;
   vertexPositionBuffer.numItems = 24;

   vertexTextureCoordBuffer = gl.createBuffer();
   gl.bindBuffer(gl.ARRAY_BUFFER, vertexTextureCoordBuffer);
   gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertexTextureCoords), gl.STATIC_DRAW);
   vertexTextureCoordBuffer.itemSize = 2;
   vertexTextureCoordBuffer.numItems = 24;

   vertexNormalBuffer = gl.createBuffer();
   gl.bindBuffer(gl.ARRAY_BUFFER, vertexNormalBuffer);
   gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertexNormals), gl.STATIC_DRAW);
   vertexNormalBuffer.itemSize = 3;
   vertexNormalBuffer.numItems = 24;

   return new Buffers(vertexPositionBuffer, vertexTextureCoordBuffer, vertexNormalBuffer, null);
}

Pin.prototype.Draw = function() {
   gl.bindBuffer(gl.ARRAY_BUFFER, this.buffers.positionBuffer);
   gl.vertexAttribPointer(currentProgram.vertexPositionAttribute, this.buffers.positionBuffer.itemSize, gl.FLOAT, false, 0, 0);

   gl.bindBuffer(gl.ARRAY_BUFFER, this.buffers.normalBuffer);
   gl.vertexAttribPointer(currentProgram.vertexNormalAttribute, this.buffers.normalBuffer.itemSize, gl.FLOAT, false, 0, 0);

   gl.bindBuffer(gl.ARRAY_BUFFER, this.buffers.textureCoordBuffer);
   gl.vertexAttribPointer(currentProgram.textureCoordAttribute, this.buffers.textureCoordBuffer.itemSize, gl.FLOAT, false, 0, 0);

   gl.activeTexture(gl.TEXTURE0);
   gl.bindTexture(gl.TEXTURE_2D, this.texture);
   gl.uniform1i(currentProgram.samplerUniform, 0);

  // gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.buffers.indexBuffer);
   setMatrixUniforms();
  // console.log(this.buffers.vertexCount + " asdf " + this.buffers.indexBuffer.numItems);
  // gl.drawElements(gl.TRIANGLES, this.buffers.indexBuffer.numItems, gl.UNSIGNED_SHORT, 0);
      gl.drawArrays(gl.TRIANGLES, 0, this.buffers.positionBuffer.numItems);

}

// Global functions
function mvPushMatrix() {
   var copy = mat4.create();
   mat4.set(mvMatrix, copy);
   mvMatrixStack.push(copy);
}

function mvPopMatrix() {
   if (mvMatrixStack.length == 0) {
      throw "Invalid popMatrix!";
   }
   mvMatrix = mvMatrixStack.pop();
}

function HandleLoadedTexture(texture) {
   gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, true);
   gl.bindTexture(gl.TEXTURE_2D, texture);
   gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, texture.image);
   gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
   gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_NEAREST);
   gl.generateMipmap(gl.TEXTURE_2D);

   gl.bindTexture(gl.TEXTURE_2D, null);
}

function setMatrixUniforms() {
   gl.uniformMatrix4fv(currentProgram.pMatrixUniform, false, pMatrix);
   gl.uniformMatrix4fv(currentProgram.mvMatrixUniform, false, mvMatrix);

   var normalMatrix = mat3.create();
   mat4.toInverseMat3(mvMatrix, normalMatrix);
   mat3.transpose(normalMatrix);
   gl.uniformMatrix3fv(currentProgram.nMatrixUniform, false, normalMatrix);
}
